
#    Note:  This is loaded into the namespace  NewMerger

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

       variable NLinks 64
       variable LinksAvailable
       variable LinksInUse

    variable LinkInUse
    for {set i 0} {$i < $NLinks} {incr i} {set LinkInUse($i) 0}
    variable LinkAlive
    for {set i 0} {$i < $NLinks} {incr i} {set LinkAlive($i) 0}
    variable LinkCtrl
    for {set i 0} {$i < $NLinks} {incr i} {set LinkCtrl($i) 0}
    variable LinkState
    for {set i 0} {$i < $NLinks} {incr i} {set LinkState($i) 0}
    variable LinkStatus
    for {set i 0} {$i < $NLinks} {incr i} {set LinkStatus($i) 0}
    variable LinkColour
    for {set i 0} {$i < $NLinks} {incr i} {set LinkColour($i) white}
    variable LinkData
    for {set i 0} {$i < $NLinks} {incr i} {set LinkData($i) white}

    variable LinkTcpPort
    for {set i 0} {$i < $NLinks} {incr i} {set LinkTcpPort($i) 0}


   proc  show_variables {} {
      variable NLinks
      variable NRows
      variable NCols
      variable LinkTcpPort
      variable LinkState
      variable LinkStatus
      variable LinkInUse
      variable LinkCtrl

       make-UIregisters

       InsertLog "Merge State = [ReadNetVar NetVar.MERGE.State]"
       InsertLog "Merge Pause/Resume State = [ReadNetVar NetVar.MERGE.Paused]"
       InsertLog "Merge Run Options = [ReadNetVar NetVar.MERGE.RunOptions]"
       InsertLog "Merge Hardware Version = [ReadNetVar NetVar.MERGE.HardwareVersion]"

       InsertLog "NLinks = $NLinks; NCols = $NCols; NRows = $NRows"
       InsertLog "LinksAvailable = [ReadNetVar NetVar.MERGE.LinksAvailable]"
       InsertLog "LinksAlive = [ReadNetVar NetVar.MERGE.Links.Alive]"
       InsertLog "LinksInUse = [ReadNetVar NetVar.MERGE.Links.InUse]"

       set data [split [ReadNetVar NetVar.MERGE.Links.InUse] %]
       for {set i 0} {$i < $NLinks} {incr i} {
          set LinkInUse($i) [lindex $data $i]
          InsertLog "$i LinkInUse = $LinkInUse($i)"
       }

       set data [ReadNetVar NetVar.MERGE.Link.TcpPort]
       for {set i 0} {$i < $NLinks} {incr i} {
          set LinkTcpPort($i) [expr [lindex $data [expr $i*2]]]
       }

       for {set link 0} {$link < $NLinks} {incr link} {
          InsertLog "$link LinkTcpPort = [set LinkTcpPort($link)]"
       }

       set data [ReadNetVar NetVar.MERGE.Link.Alive]
       for {set i 0} {$i < $NLinks} {incr i} {
          set LinkAlive($i) [expr [lindex $data [expr $i*2]]]
       }

       for {set link 0} {$link < $NLinks} {incr link} {
          InsertLog "$link LinkAlive = [set LinkAlive($link)]"
       }

       set data [ReadNetVar NetVar.MERGE.Link.State]
       for {set i 0} {$i < $NLinks} {incr i} {
          set LinkState($i) [expr [lindex $data [expr $i*2]]]
       }

       for {set link 0} {$link < $NLinks} {incr link} {
          InsertLog "$link LinkState = [set LinkState($link)]"
       }

       set data [ReadNetVar NetVar.MERGE.Link.Status]
       for {set i 0} {$i < $NLinks} {incr i} {
          set LinkStatus($i) [expr [lindex $data [expr $i*2]]]
       }

       for {set link 0} {$link < $NLinks} {incr link} {
          InsertLog "$link LinkStatus = [set LinkStatus($link)]"
       }

       set data [ReadNetVar NetVar.MERGE.Link.Ctrl]
       for {set i 0} {$i < $NLinks} {incr i} {
          set LinkCtrl($i) [expr [lindex $data [expr $i*2]]]
       }

       for {set link 0} {$link < $NLinks} {incr link} {
          InsertLog "$link LinkCtrl = [set LinkCtrl($link)]"
       }

   }

   proc doState {} {
       variable NLinks
       variable LinksAvailable
       variable LinkInUse
       variable LinkAlive

      UpdateMergeLinks

      InsertLog "MERGE.State = [ReadNetVar NetVar.MERGE.State]"
      InsertLog "MERGE.Paused = [ReadNetVar NetVar.MERGE.Paused]"
      InsertLog "MERGE.RunOptions = [ReadNetVar NetVar.MERGE.RunOptions]"

      InsertLog "LinksAvailable: $LinksAvailable"
 
       set txt ""
       for {set link 0} {$link < $NLinks} {incr link} {
           if {$link < $LinksAvailable} then {
              if {$LinkInUse($link) == 1} then {
                  append txt "$link "
              }
           }
       }
       InsertLog "LinksInUse: $txt"

       set txt ""
       for {set link 0} {$link < $NLinks} {incr link} {
           if {$link < $LinksAvailable} then {
              if {$LinkAlive($link) != 0} then {
                  append txt "$link "
              }
           }
       }
       InsertLog "LinksAlive: $txt"

       for {set link 0} {$link < $NLinks} {incr link} {
           if {$link < $LinksAvailable} then {
              if {$LinkInUse($link) == 1 && $LinkAlive($link) == 0} then {
                  InsertLog "Warning: Link $link is in use but is NOT alive"
              }
           }
       }
   }

   proc doLink {i} {
      variable LinkInUse

       set LinkInUse($i) [expr ([set LinkInUse($i)] + 1) & 1]

       store_MergeLinks
   }

   proc UpdateMergeLinks {} {
       variable NLinks
       variable LinksAvailable
       variable LinkInUse
       variable LinkAlive
       variable LinkStatus
       variable LinkState
       variable LinkColour
       variable LinkData

       set LinksAvailable  [ReadNetVar NetVar.MERGE.LinksAvailable]
       set LinksAlive  [ReadNetVar NetVar.MERGE.Links.Alive]
       set LinksInUse [split [ReadNetVar NetVar.MERGE.Links.InUse] %]

       set State [ReadNetVar NetVar.MERGE.Link.State]
       set Status [ReadNetVar NetVar.MERGE.Link.Status]
       set Alive [ReadNetVar NetVar.MERGE.Link.Alive]

       for {set link 0} {$link < $NLinks} {incr link} {
           set LinkInUse($link) [lindex $LinksInUse $link]
           set LinkAlive($link) [expr [lindex $Alive [expr $link*2]]]
           set LinkStatus($link) [expr [lindex $Status [expr $link*2]]]
           set LinkState($link) [expr [lindex $State [expr $link*2]]]
       }

       for {set link 0} {$link < $NLinks} {incr link} {
           if {$link < $LinksAvailable} then {
              if {$LinkInUse($link) == 0} then {
                 if {$LinkState($link) == 1} {   ;# LINK_ISIDLE
                     set LinkColour($link) red
                 } else {
                     set LinkColour($link) DarkGoldenRod
                 }
              } else {
                 if {$LinkAlive($link) == 2} {   ;# LINK_GOING
                     set LinkColour($link) LimeGreen
                 } else {
                     set LinkColour($link) DarkOliveGreen
                 }
              }
           } else {
              if {$LinkInUse($link) == 0} then {
                     set LinkColour($link) grey
              } else {
                     set LinkColour($link) black
              }
           }
       }

       for {set link 0} {$link < 4} {incr link} {
           set data [ReadNetVar NetVar.MERGE.Rates[expr 1+$link]]
           set i 4
           set rate [expr [lindex $data [expr $i*2]]]
           if {$link < $LinksAvailable} then {
               if {$rate == 0} {set LinkData($link) red} else {set LinkData($link) green}
           } else {
               set LinkData($link) black
           }
       }
  }
 
   proc PageNotes {} {InsertLog "Notes in preparation"}

   proc TestRun {} {puts "starting TestRun"}

   proc DataBufferStatus {} {MergeCommand 9 "Data Buffer Status"}

   proc DataBufferFreeAll {} {MergeCommand 8 "Release all Data Buffers"}

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   NOTES    {PageNotes}

                   MERGE {doMerge $vl; after 5000; ::NewMerger::UpdateMergeLinks}

                   STATE  {doState}
                   LINKS  {doLink $vl}

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        UpdateMergeLinks
     }

    catch {load_MergeLinks}
    catch {UpdateMergeLinks}

}   ;# end of if {$started == 0}




