/*
    Data buffer process code for R3B
    
    Initial version which omits data checks
*/

int processR3BDATAbuffer(ItDesc_Ptr ps, NewItDesc_Ptr pd, int l /*units of ItDesc*/) 
{

    int len;
    int module = 0;
    int channel = 0;
    int traceflag = 0;;
    
    int ASIC = 0;
    int ChannelID = 0;
    int chID = 0;
    int modID = 0;
    int asicID = 0;
	
    unsigned int chan;
    unsigned int * databuffer;
    ItDesc_Ptr ip;
    NewItDesc_Ptr op;
    unsigned long data;
    unsigned short adc;
    unsigned short icode;
    unsigned int ifield;
    unsigned int samplelen;
    unsigned long timestamp;
    int i, j;
    int count;
    int samples;
    
    extern int MODULE;
     
    extern unsigned long wr4863;

    extern unsigned long Time0027;
    extern unsigned long Time2847;
    extern unsigned long Time4863;
    extern unsigned long long INFO4;
    extern unsigned long long INFO7;

    extern unsigned long long WRTimeF;
    extern unsigned long long timestampF;

    extern unsigned long WRTime0027;
    extern unsigned long WRTime2847;
    extern unsigned long WRTime4863;

    extern unsigned long long LastTimeStamp;

    unsigned int TotalItems;


    len = l*2;    //   units of int
    databuffer = (unsigned int *) ps;


    if (*MERGE_Verbose > 2) {

       len = l*2;    //   units of int
       databuffer = (unsigned int *) ps;

       printf("processDATAbuffer len=%d\n",len);

       printf(">\n");

       for (j = 0; j < 8; j++) {
         for (i = 0; i < 16; i++)
         {
            printf("%08lx ", *databuffer++);
         }
         printf("\n");
       }
    }

    len = l;                 /*   len in units of unsigned long long (ItDesc) */
    ip = ps;
    op = pd;

    TotalItems = 0;    /*   output length (NewItDesc)  */

    if (*MERGE_Verbose != 0) sprintf(message_buffer, "Block received link %d, length %d\n", LinkNum, len );
    report_message(MSG_TRACE);

    while (len > 0)
    {

        data = ip->data;
        timestamp = ip->timestamp;
        ip++; len--;

       if (*MERGE_Verbose != 0)  sprintf(message_buffer, "raw data: link=%d state=%d, H=0x%08lx L=0x%08lx", LinkNum, link_table[LinkNum]->link_state, data, timestamp);
        report_message(MSG_TRACE);

        op->Data = data;
        op->Timestamp = timestamp;

        op->Code = NULL_CODE;
        op->Info = 0;
        op->Time = 0;   /*  unsigned long long  */

        if (data == 0xffffffff) {break;}

    (*StatsMem[TOTALITEMS])++;           /* counter for number of data items */
    (*StatsMem[TOTALITEMS+((LinkNum+1)*MAXCOUNTERS)])++;

        switch ((data >> 30 ) & 3) {

             case 3:             /*  ADC data word */

    (*StatsMem[ADCDATA])++;           /* counter for number of ADC data words */
    (*StatsMem[ADCDATA+((LinkNum+1)*MAXCOUNTERS)])++;

                ChannelID = (data >> 12) & 0x0001fff;
		channel = ChannelID & 127;
		ASIC = (ChannelID >> 7) & 15;
                module = (ChannelID >> 11) & 63;
		
		modID = module;
		asicID = ASIC;
		chID = channel;
		
                adc = (unsigned short) (data & 0x00000fff);

                Time0027 = timestamp;
                Time2847 = (INFO7 >> 28) & 0x000fffff;
                timestampF = ((unsigned long long) Time2847 << 28) | (unsigned long long) Time0027;

                WRTime0027 = Time0027;
                WRTime2847 = Time2847;

                WRTimeF = ((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027;

                if (*MERGE_Verbose != 0) sprintf(message_buffer, "adc data: link %d, 0x%04x module=%d channel=%d: H=0x%08lx L=0x%08lx: TS=0x%016llx WR=0x%016llx", LinkNum, adc, module, channel, data, timestamp, timestampF, WRTimeF);
                report_message(MSG_TRACE);
		
		if (MODULE != 0 && MODULE != module) {op->Code = NULL_CODE; break;}

                op->Data = (3 << 30) | (1 << 29) | (module << 22) | (asicID << 19)  | (channel << 12) | adc;
                op->Code = ADC_CODE;
                op->Time = WRTimeF;
                
                break;
     
             case 2:    /*  information data word */

                icode = (data >> 20) & 15;    /*  information code */
                ifield = data & 0x000fffff;     /*  information field */
                module = (data >> 24) & 63;

                module = LinkNum;

                op->Data = (2 << 30) | (module << 24) | (icode << 20) | ifield;
		op->Code = NULL_CODE;

                switch (icode) {
 
                    case 2:         /* PAUSE timestamp */

                       (*StatsMem[PAUSE])++;           /* counter for number of PAUSE items */
                       (*StatsMem[PAUSE+((LinkNum+1)*MAXCOUNTERS)])++;

                       Time0027 = timestamp;
                       Time2847 = ifield;
                       timestampF = ((unsigned long long) Time2847 << 28) | (unsigned long long) Time0027;
		       
                       WRTime0027 = Time0027;
                       WRTime2847 = Time2847;

                       WRTimeF = ((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027;

		       if (*MERGE_Verbose != 0) sprintf(message_buffer, "received PAUSE: link %d, ifield=0x%05x: H=0x%08lx L=0x%08lx TS=0x%016llx", LinkNum, ifield, data, timestamp, timestampF);
                       report_message(MSG_TRACE);
		     
		       if (MODULE != 0 && MODULE != module) break;

                       op->Code = PAUSE_CODE;
                       op->Time = WRTimeF;

                       break;

                    case 3:         /* RESUME timestamp */

                       (*StatsMem[RESUME])++;           /* counter for number of RESUME items */
                       (*StatsMem[RESUME+((LinkNum+1)*MAXCOUNTERS)])++;

                       Time0027 = timestamp;
                       Time2847 = ifield;
                       timestampF = ((unsigned long long) Time2847 << 28) | (unsigned long long) Time0027;

                       WRTime0027 = Time0027;
                       WRTime2847 = Time2847;

                       WRTimeF = ((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027;
		       
		       if (*MERGE_Verbose != 0) sprintf(message_buffer, "received RESUME: link %d, ifield=0x%05x: H=0x%08lx L=0x%08lx TS=0x%016llx", LinkNum, ifield, data, timestamp, timestampF);
                       report_message(MSG_TRACE);
		       
		       if (MODULE != 0 && MODULE != module) break;

                       op->Code = RESUME_CODE;
                       op->Time = WRTimeF;
    
                       break;

                    case 4:         /* INFO4 timestamp /  WR timestamp L      sequence info5 ; info4  */

                       (*StatsMem[SYNCITEM])++;           /* counter for number of INFO4 items */
                       (*StatsMem[SYNCITEM+((LinkNum+1)*MAXCOUNTERS)])++;

                       Time0027 = timestamp;
                       Time2847 = ifield;
                       timestampF = ((unsigned long long) Time2847 << 28) | (unsigned long long) Time0027;

                       WRTime0027 = timestamp;
                       WRTime2847 = ifield;

                       WRTimeF = ((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027;

                       if (*MERGE_Verbose != 0) sprintf(message_buffer, "received WR Low TS: link %d, H=0x%08lx L=0x%08lx 0x%08lx 0x%08lx 0x%08lx TS=0x%016llx  WR=0x%016llx", LinkNum, data, timestamp, WRTime0027, WRTime2847, WRTime4863, timestampF, WRTimeF);
                       report_message(MSG_TRACE);
		       
		       if (MODULE != 0 && MODULE != module) break;

                       INFO4 = timestampF;

                       op->Code = INFO4_CODE;
                       op->Time = WRTimeF;

                       break;

                    case 5:         /* WR timestamp H */

                       (*StatsMem[WR])++;           /* counter for number of WR H data words */
                       (*StatsMem[WR+((LinkNum+1)*MAXCOUNTERS)])++;

                       Time0027 = timestamp;

                       WRTime0027 = Time0027;
                       WRTime4863 = ifield & 0x0000ffff;

                       WRTimeF = ((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027;

                       if (*MERGE_Verbose != 0) sprintf(message_buffer, "received WR High TS: link %d, H=0x%08lx L=0x%08lx 0x%08lx 0x%08lx 0x%08lx TS=0x%016llx WR=0x%016llx", LinkNum, data, timestamp, WRTime0027, WRTime2847, WRTime4863, timestampF, WRTimeF);
                       report_message(MSG_TRACE);

		       if (MODULE != 0 && MODULE != module) break;

                       wr4863 = WRTime4863;   /* used in merge.c  */

                       op->Code = WR_CODE;
                       op->Time = WRTimeF;

                       break;

                    case 7:         /* INFO7 timestamp  */

                       (*StatsMem[INFO7ITEM])++;           /* counter for number of INFO7 items */
                       (*StatsMem[INFO7ITEM+((LinkNum+1)*MAXCOUNTERS)])++;

                       Time0027 = timestamp;
		       
                       Time2847 = ifield;
                       timestampF = ((unsigned long long) Time2847 << 28) | (unsigned long long) Time0027;

                       WRTime0027 = timestamp;
                       WRTime2847 = ifield;

                       WRTimeF = ((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027;

                       if (*MERGE_Verbose != 0) sprintf(message_buffer, "received INFO#7: link %d, H=0x%08lx L=0x%08lx 0x%08lx 0x%08lx 0x%08lx TS=0x%016llx  WR=0x%016llx", LinkNum, data, timestamp, WRTime0027, WRTime2847, WRTime4863, timestampF, WRTimeF);
                       report_message(MSG_TRACE);
		       
		       if (MODULE != 0 && MODULE != module) break;
		       
		       INFO7 = timestampF;

                       op->Code = INFO7_CODE;
                       op->Time = WRTimeF;

                       break;

                    case 14:         /* R3B external trigger #1 */

                       (*StatsMem[EXT1])++;           /* counter for number of correlation scaler data words */
                       (*StatsMem[EXT1+((LinkNum+1)*MAXCOUNTERS)])++;

                       Time0027 = timestamp;
		       
                       Time2847 = (INFO4 >> 28) & 0x000fffff;
                       timestampF = ((unsigned long long) Time2847 << 28) | (unsigned long long) Time0027;
		
                       WRTime0027 = Time0027;
                       WRTime2847 = Time2847;

                       WRTimeF = ((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027;
		       
                       if (*MERGE_Verbose != 0) sprintf(message_buffer, "received R3B Ext Trig 1: link %d, 0x%05x:  H=0x%08lx L=0x%08lx TS=0x%016llx", LinkNum, ifield, data, timestamp, timestampF);
                       report_message(MSG_TRACE);

 		       if (MODULE != 0 && MODULE != module) break;

                       op->Code = R3B_EXT1_CODE;
                       op->Time = WRTimeF;

                       break;

                    case 15:         /* R3B external trigger #2 */

                       (*StatsMem[EXT2])++;           /* counter for number of correlation scaler data words */
                       (*StatsMem[EXT2+((LinkNum+1)*MAXCOUNTERS)])++;

                       Time0027 = timestamp;
		       
                       Time2847 = (INFO4 >> 28) & 0x000fffff;
                       timestampF = ((unsigned long long) Time2847 << 28) | (unsigned long long) Time0027;
		       
		       WRTime0027 = Time0027;
                       WRTime2847 = Time2847;

                       WRTimeF = ((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027;

                       if (*MERGE_Verbose != 0) sprintf(message_buffer, "received R3B Ext Trig 2: link %d, 0x%05x:  H=0x%08lx L=0x%08lx TS=0x%016llx", LinkNum, ifield, data, timestamp, timestampF);
                       report_message(MSG_TRACE);
		       
		       if (MODULE != 0 && MODULE != module) break;

                       op->Code = R3B_EXT2_CODE;
                       op->Time = WRTimeF;

                       break;

                    default:        /* undefined code */

                       (*StatsMem[BADINFO])++;           /* counter for number of undefined data items */
                       (*StatsMem[BADINFO+((LinkNum+1)*MAXCOUNTERS)])++;

                       sprintf(message_buffer, "received undefined information code: %d", icode);
                       report_message(MSG_WARNING);
		      
                       break;
                }
        
                break;

             case 1:       /* wave form data */
             case 0:       /*  bad format */
             default:    

                (*StatsMem[IGNORE2])++;
                (*StatsMem[IGNORE2+((LinkNum+1)*MAXCOUNTERS)])++;

                sprintf(message_buffer, "bad event data (%d %d) - (0x%08lx 0x%08lx)", l/4, len, data, timestamp);
                report_message(MSG_WARNING);
		
		op->Code = NULL_CODE;
		
                len = 0;
                break;

         }   /*   end of switch */

         if (*MERGE_Verbose != 0) sprintf(message_buffer, "process item %d %d 0x%x 0x%08lx 0x%08lx TS=0x%016llx 0x%016llx",LinkNum, link_table[LinkNum]->link_state, op->Code, op->Data, op->Timestamp, op->Time, LastTimeStamp);
         report_message(MSG_TRACE);
	 
         if (op->Code == NULL_CODE) goto L00;

         if (op->Code == WR_CODE || op->Code == INFO4_CODE || op->Code == INFO7_CODE) goto L00;

/*
     add this data item to the queue for merging
*/

               if (*MERGE_Verbose != 0) sprintf(message_buffer, "good timestamp %d %d 0x%08lx 0x%08lx 0x%016llx 0x%016llx 0x%016llx",LinkNum, link_table[LinkNum]->link_state, op->Data, op->Timestamp, INFO4, op->Time, LastTimeStamp);
               report_message(MSG_TRACE);

               LastTimeStamp = op->Time;

               *StatsMem[TLOW] = (unsigned long)(LastTimeStamp & 0x00000000ffffffffull);
               *StatsMem[THIGH] = (unsigned long)((LastTimeStamp >> 32) & 0x00000000ffffffffull);

               *StatsMem[TLOW+((LinkNum+1)*MAXCOUNTERS)] = (unsigned long)(LastTimeStamp & 0x00000000ffffffffull);
               *StatsMem[THIGH+((LinkNum+1)*MAXCOUNTERS)] = (unsigned long)((LastTimeStamp >> 32) & 0x00000000ffffffffull);

               op++;   /*   advance output pointer */
               TotalItems++;

 
L00:  continue;   /* if op->Code == NULL_CODE or  == WR_CODE  */
    } /* end of while len  > 0 */


    return TotalItems;
}

