

   for (;;) {

       if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master entering wait_for_wakeup");
       report_message(MSG_TRACE);

       Signal = wait_for_wakeup ();

        sscanf(MERGE_Parameter,"%d",&linkNum);
        if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received signal=%d;  Action=%d; Parameter=%s %d",Signal,*MERGE_Action,MERGE_Parameter,linkNum);
        report_message(MSG_DEBUG);

/*
    Signal 10 is SIGUSR1
    Signal 12 is SIGUSR2

    Signal 35 is SIGWAKEUP  (SIGRTMIN+1)
*/

       switch (Signal) {

         case 0:
           if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received signal 0");
           report_message(MSG_TRACE);
           break;

         case SIGUSR1:
           if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received signal SIGUSR1");
           report_message(MSG_TRACE);
           break;

         case SIGUSR2:
           if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received signal SIGUSR2");
           report_message(MSG_TRACE);

           switch (*MERGE_Action) {
              case 0:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action 0");
                 report_message(MSG_TRACE);
                 break;

              case DO_SETUP:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action   merge Setup");
                 report_message(MSG_TRACE);
                 *MERGE_Command = MERGE_DOINGSETUP;
                 wakeup_merge();     (*StatsMem[WAKEUPMERGE])++;
                 break;

              case DO_STOP:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action   merge Stop");
                 report_message(MSG_TRACE);
                 *MERGE_Command = MERGE_DOINGSTOP;
                 wakeup_merge();    (*StatsMem[WAKEUPMERGE])++;
                 break;

              case DO_GO:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action   merge Go");
                 report_message(MSG_TRACE);
                 *MERGE_Command = MERGE_DOINGGO;
                 wakeup_merge();     (*StatsMem[WAKEUPMERGE])++;
                 break;

              case DO_RESET:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action   merge Reset");
                 report_message(MSG_TRACE);
                 *MERGE_Command = MERGE_DOINGRESET;
                 wakeup_merge();    (*StatsMem[WAKEUPMERGE])++; 
                 break;

              case DO_START:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action   merge Start");
                 report_message(MSG_TRACE);
                 *MERGE_Command = MERGE_EXECUTING;
                 break;

              case DO_PAUSE:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action   merge Pause");
                 report_message(MSG_TRACE);
                 *MERGE_Command = MERGE_EXECUTING;
                 wakeup_merge();    (*StatsMem[WAKEUPMERGE])++; 
                 break;

              case DO_RESUME:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action   merge Resume");
                 report_message(MSG_TRACE);
                 *MERGE_Command = MERGE_EXECUTING;
                 wakeup_merge();    (*StatsMem[WAKEUPMERGE])++; 
                 break;

              case 8: 
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action   8 - release all data buffers");
                 report_message(MSG_INFORMATION);
                 release_all_data_buffers(); 
                 break;

              case 9: 
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action   9 - report data buffer status");
                 report_message(MSG_INFORMATION);
                 report_data_buffer_state();   /* report for all active links  */
                 break;

              case MERGE_ZEROTS:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action  merge  zero time stamp");
                 report_message(MSG_TRACE);
                 *MERGE_Command = MERGE_ZEROTS;
                 wakeup_merge();    (*StatsMem[WAKEUPMERGE])++; 
                 break;

              case 11:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action 11  -   disconnect xfer stream");
                 report_message(MSG_TRACE);
                 break;

              case 12:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action 12  -   connect xfer stream");
                 report_message(MSG_TRACE);
                 break;

              case LINK_STOP:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action  'link %d stop' ",linkNum);
                 report_message(MSG_TRACE);

                 link_table[linkNum]->link_ctrl = LINK_STOP;
                 link_table[linkNum]->link_state = LINK_DOINGSTOP;
                 wakeup_link(link_table[linkNum]->link_pid);   (*StatsMem[WAKEUPLINK])++;  (*StatsMem[WAKEUPLINK+((i+1)*MAXCOUNTERS)])++;
                 break;

              case LINK_GO:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action  'link %d go' ",linkNum);
                 report_message(MSG_TRACE);

                 link_table[linkNum]->link_ctrl = LINK_GO;
                 link_table[linkNum]->link_state = LINK_DOINGGO;
                 wakeup_link(link_table[linkNum]->link_pid);   (*StatsMem[WAKEUPLINK])++;  (*StatsMem[WAKEUPLINK+((i+1)*MAXCOUNTERS)])++;
                 break;

              case LINK_IDLE:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action  'link  idle' for link  %d",linkNum);
                 report_message(MSG_TRACE);
                 link_table[linkNum]->link_ctrl  = LINK_IDLE;
                 link_table[linkNum]->link_state = LINK_DOINGIDLE;
                 wakeup_link(Linkpid[linkNum]);  (*StatsMem[WAKEUPLINK])++;  (*StatsMem[WAKEUPLINK+((linkNum+1)*MAXCOUNTERS)])++;
                 break;

              case LINK_FLUSH:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action  'link  flush' for link  %d",linkNum);
                 report_message(MSG_TRACE);
                 link_table[linkNum]->link_ctrl  = LINK_FLUSH;
                 link_table[linkNum]->link_state = LINK_EXECUTING;
                 wakeup_link(Linkpid[linkNum]); (*StatsMem[WAKEUPLINK])++;  (*StatsMem[WAKEUPLINK+((linkNum+1)*MAXCOUNTERS)])++;
                 break;

              case LINK_RESET:
                 if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received Action  'link  reset' for link  %d",linkNum);
                 report_message(MSG_TRACE);
                 link_table[linkNum]->link_ctrl  = LINK_RESET;
                 link_table[linkNum]->link_state = LINK_DOINGRESET;
                 wakeup_link(Linkpid[linkNum]); (*StatsMem[WAKEUPLINK])++;  (*StatsMem[WAKEUPLINK+((linkNum+1)*MAXCOUNTERS)])++;
                 break;;

              default:
                sprintf(message_buffer,"Undefined Action %d received", *MERGE_Action);
                report_message(MSG_WARNING);
                break;
           }
           break;

         case 35:
           if (*MERGE_Verbose != 0)  sprintf(message_buffer,"master received signal SIGWAKEUP");
           report_message(MSG_TRACE);
           break;

         default:
           sprintf(message_buffer,"Unhandled Signal %d received", Signal);
           report_message(MSG_WARNING);
           break;
       }

       *MERGE_Signal = 0;   /* clear signal */
       *MERGE_Action = 0;    /* and clear Action  */

   }

