

/*
    This code is the Statistics/Rates task
*/


#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h> /* getenv, exit */
#include <errno.h>

#include <pthread.h>
#include <unistd.h>

#include "common.h"
#include "message.h"

#include "stats.h"
#include "netvar.h"

void stats_zero();

extern int * StatsMem[NUMCOUNTERS];   /* MAXCOUNTERS + (MAXCOUNTERS * (NUMLINKS+2));  MAXOUNTERS=64  NUMLINKS=64  */
extern int * RatesMem[NUMCOUNTERS];
extern int * MERGE_StatsTime;
extern int * MERGE_ZeroStats;
extern int * MERGE_State;

int Counts[NUMCOUNTERS];

char message [160];    /*  message logger message buffer   */


/* --------------------------------------------------------------------- */


void stats_server()
{

   int i, j;
   int ScratchNetInt;
   int maxcounters=MAXCOUNTERS;
   int numcounters=NUMCOUNTERS;


     printf("MERGE Statistics thread starting\n");

    signal_block();       //    mask off signals handled by the main thread

//   adjust priority - run just above main data acquisition program

     nice(-2);

//    initialise Stats Rates NetVar arrays

       for (i=0; i<(numcounters/maxcounters); i++) {
          sprintf(message,"MERGE_Stats%d",i);
          readNetInt(message, 0, 1, &ScratchNetInt);
       }

       for (i=0; i<(numcounters/maxcounters); i++) {
          sprintf(message,"MERGE_Rates%d",i);
          readNetInt(message, 0, 1, &ScratchNetInt);
       }

       for(i=0;i<numcounters;i++) {
           Counts[i]=0;
           j = i-((i/maxcounters)*maxcounters);
           sprintf(message,"MERGE_Stats%d",(i/maxcounters));
           StatsMem[i] = (int *)getNetIntArrayMem(message,j);
           sprintf(message,"MERGE_Rates%d",(i/maxcounters));
           RatesMem[i] = (int *)getNetIntArrayMem(message,j);
       }


  for (;;)
  {

     if (*MERGE_State != MERGE_GOING) {

         for(i=0;i<numcounters;i++) {*RatesMem[i] = 0;}
     }

     usleep ((*MERGE_StatsTime)*1000000);  /* delay in secs */ 

       if (*MERGE_ZeroStats == 1) {
           assignNetInt("MERGE_ZeroStats", 0, 1, 0);   /* clear action request */
           stats_zero();
       }

//    update rates

     for(i=0;i<numcounters;i++) {
         *RatesMem[i]=(*StatsMem[i]-Counts[i])/(*MERGE_StatsTime);
         Counts[i]=*StatsMem[i];
     }

  }
}

/* --------------------------------------------------------------------- */

void stats_zero()
{
   int i;

/*    clear stats counters   */

   for(i=0;i<NUMCOUNTERS;i++) {*StatsMem[i] = 0; Counts[i] = 0;}

  printf("MERGE Statistics counters now cleared\n");
}

/* --------------------------------------------------------------------- */

