

/* --------------------------------------------------------------------- */

int errnum = 0;

void get_Events()
{
    unsigned int * itemptr;
    unsigned int * ptr;
    unsigned int data32;
    int ChanIdent;
    int infoCode;
    int rc;

    unsigned long long TimeStampF = 0;
    unsigned long long WRTimeF = 0;
    unsigned long long WRTime7F = 0;
    unsigned long long CurrentTime;

    int ModID = 0;
    

    if (R3BTrace) printf ("get_Events\n");

    itemptr =  (unsigned int *)&DataBuffer[DataBufferOffset];  //  input data 
    ptr = (unsigned int *)eventbuffer;      // output buffer

    EventLen = 0;

    for (;;) {

        if (DataBufferLen == 0) return;
        if (EventLen > 1024) return;      /* this is 8K bytes */

        Event0 = *itemptr++;
    
        DataBufferLen--;
        DataBufferOffset++;
        
        Event1 = *itemptr++;
    
        DataBufferLen--;
        DataBufferOffset++;

        EventLen++;    /* items */
        Stats[DATAITEM]++;

        R3B_FifoBuffer[R3B_FifoBufferPtr] = Event0;
        if (++R3B_FifoBufferPtr == R3BFIFOBUFFERLENGTH) R3B_FifoBufferPtr = 0;

        R3B_FifoBuffer[R3B_FifoBufferPtr] = Event1;
        if (++R3B_FifoBufferPtr == R3BFIFOBUFFERLENGTH) R3B_FifoBufferPtr = 0;

        if (PreEvent0 == Event0 && PreEvent1 == Event1) Stats[DATAERR]++;
        PreEvent0 = Event0;
        PreEvent1 = Event1;

        if (((Event0 >> 30) & 3) == 3) {     /*  ADC data format */
           Stats[R3BEVENTS]++;

            ModID = (Event0 >> 23) & 0x3e;
            if (ModID != R3B_ModID) Stats[BADMODID]++;

           WRTime0027 = Event1 & 0x0fffffff;
           WRTimeF = (unsigned long long) WRTime7F | (unsigned long long) WRTime0027;
           WRTimeF = (unsigned long long)(WRTimeF * 1ull);                            /* convert to 1ns resolution */

           Event1 = (unsigned long) WRTimeF & 0x0fffffff;

           *ptr++ = Event0;
           *ptr++ = Event1;
           EventBufferLen += 4;   /*shorts*/
        
           if ((Event0 >> 29) & 1 == 1) {    /*   Hit bit set   */
               Stats[HITITEM]++;
           } else {
               Stats[NOHITITEM]++;
           }

/*
           ChanIdent = (Event0 >> 12) & 0x0fff;
           CurrentTime = ((unsigned long long) WRTime2847 << 28) + (unsigned long long) (Event1 & 0x0fffffff);
           if (ChanWRTime[ChanIdent] != 0) {
              ChanWRTimeDiff[ChanIdent] = CurrentTime - ChanWRTime[ChanIdent];
           }
           ChanWRTime[ChanIdent] = CurrentTime;
*/

           continue;
        }       /* end of  "ADC data format" */
    
        if (((Event0 >> 30) & 3) != 2) {     /*  invalid data format */
            Stats[DATAERR]++;
            continue;
        }

//    handle INFO data words 

//        ModID = (Event0 >> 24) & 0x3f;
//        if (ModID != R3B_ModID) Stats[BADMODID]++;

        infoCode = (Event0 >> 20) & 15;
        switch (infoCode) {

             case 2:           /*   pause   */
               Stats[PAUSE]++;
               WRTime2847 = Event0 & 0x000fffff;
               WRTime0027 = Event1 & 0x0fffffff;
               WRTimeF = (((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027);
               WRTimeF = (unsigned long long)(WRTimeF * 1ull);                            /* convert to 1ns resolution */

               Event0 = (2 << 30) | (ModID << 24) | (5 << 20) | ((unsigned long long) WRTimeF >> 48) & 0x0000ffff;
               Event1 = (unsigned long) WRTimeF & 0x0fffffff;
               Event2 = (2 << 30) | (ModID << 24) | (2 << 20) | ((unsigned long long) WRTimeF >> 28) & 0x000fffff;
               Event3 = (unsigned long) WRTimeF & 0x0fffffff;

               rc=1;
               break;

             case 3:           /*   resume   */
               Stats[RESUME]++;
               WRTime2847 = Event0 & 0x000fffff;
               WRTime0027 = Event1 & 0x0fffffff;
               WRTimeF = (((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027);
               WRTimeF = (unsigned long long)(WRTimeF * 1ull);                            /* convert to 1ns resolution */

               Event0 = (2 << 30) | (ModID << 24) | (5 << 20) | ((unsigned long long) WRTimeF >> 48) & 0x0000ffff;
               Event1 = (unsigned long) WRTimeF & 0x0fffffff;
               Event2 = (2 << 30) | (ModID << 24) | (3 << 20) | ((unsigned long long) WRTimeF >> 28) & 0x000fffff;
               Event3 = (unsigned long) WRTimeF & 0x0fffffff;

               rc=1;
               break;

             case 5:             /*  WR 48 => 63 WRTime INFO item */
               Stats[WR5]++;
               WRTime4863 = Event0 & 0x000fffff;

               rc=0;
               break;

             case 4:             /*   WR 0 => 47 WRTime INFO item   */
               Stats[WR4]++;
               WRTime2847 = Event0 & 0x000fffff;
               WRTime0027 = Event1 & 0x0fffffff;
               WRTimeF = (((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027);
               WRTimeF = (unsigned long long)(WRTimeF * 1ull);                            /* convert to 1ns resolution */

               Event0 = (2 << 30) | (ModID << 24) | (5 << 20) | ((unsigned long long) WRTimeF >> 48) & 0x0000ffff;
               Event1 = WRTimeF & 0x0fffffff;
               Event2 = (2 << 30) | (ModID << 24) | (4 << 20) | ((unsigned long long) WRTimeF >> 28) & 0x000fffff;
               Event3 = WRTimeF & 0x0fffffff;
               rc=1;
               break;

             case 7:        /*  WR 0 => 47 WRTime Info item  */
               Stats[TM7]++;
               WRTime2847 = Event0 & 0x000fffff;
               WRTime0027 = Event1 & 0x0fffffff;
               WRTimeF = (((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027);
               WRTimeF = (unsigned long long)(WRTimeF * 1ull);                            /* convert to 1ns resolution */

               Event0 = (2 << 30) | (ModID << 24) | (5 << 20) | ((unsigned long long) WRTimeF >> 48) & 0x0000ffff;
               Event1 = WRTimeF & 0x0fffffff;
               Event2 = (2 << 30) | (ModID << 24) | (7 << 20) | ((unsigned long long) WRTimeF >> 28) & 0x000fffff;
               Event3 = WRTimeF & 0x0fffffff;
               WRTime7F = (((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28)) & 0xfffffffff0000000ULL;
               rc=1;
               break;

             case 8:

               rc=-1;
               break;

             case 14:             /*    external trigger #1 */
               Stats[IN14]++;
               WRTime2847 = Event0 & 0x000fffff;
               WRTime0027 = Event1 & 0x0fffffff;
               WRTimeF = (((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027);
               WRTimeF = (unsigned long long)(WRTimeF * 1ull);                            /* convert to 1ns resolution */

               Event0 = (2 << 30) | (ModID << 24) | (5 << 20) |  ((unsigned long long) WRTimeF >> 48) & 0x0000ffff;
               Event1 =  WRTimeF & 0x0fffffff;
               Event2 = (2 << 30) | (ModID << 24) | (14 << 20) |  ((unsigned long long) WRTimeF >> 28) & 0x000fffff;
               Event3 = WRTime0027;

               rc=1;
               break;

             case 15:             /*   external trigger #2 */
               Stats[IN15]++;
               WRTime2847 = Event0 & 0x000fffff;
               WRTime0027 = Event1 & 0x0fffffff;
               WRTimeF = (((unsigned long long) WRTime4863 << 48) | ((unsigned long long) WRTime2847 << 28) | (unsigned long long) WRTime0027);
               WRTimeF = (unsigned long long)(WRTimeF * 1ull);                            /* convert to 1ns resolution */
               Event0 = (2 << 30) | (ModID << 24) | (5 << 20) | ((unsigned long long) WRTimeF >> 48) & 0x0000ffff;

               Event1 =  WRTimeF & 0x0fffffff;
               Event2 = (2 << 30) | (ModID << 24) | (15 << 20) | ((unsigned long long) WRTimeF >> 28) & 0x000fffff;
               Event3 =  WRTimeF & 0x0fffffff;

               rc=1;
               break;

             default:
               rc=-1;
        }   /*  end of switch */

        if (rc < 0) {
            Stats[INFOERR]++;   /* unexpected INFO word */
            continue;
        }

        if (rc == 1) {   /*  output INFO words as required  */

               *ptr++ = Event0;
               *ptr++ = Event1;
               *ptr++ = Event2;
               *ptr++ = Event3;
               EventBufferLen += 8;   /*shorts*/
        }

    }
    
}

/* --------------------------------------------------------------------- */

int get_Blk()
{
    int rc;
    unsigned int Data32=0;
    int Status, Ctrl;
    int i, l;

    int count;
    unsigned long *srcptr;          /* pointer in data buffer  */
    unsigned long *destptr;         /* address of hardware */

    if (R3BTrace) printf ("get_Blk\n");

     lseek(R3Bfh, DMA_CTRL, SEEK_SET);     // DMA Control register
     rc = read(R3Bfh, &Ctrl, 4);                 //  read it

     if ((Ctrl & 0x03) != 0x01)   return 0;    //  DMA is stopped
     
     lseek(R3Bfh, DMA_STATUS, SEEK_SET);     // DMA Status register
     rc = read(R3Bfh, &Status, 4);                 //  read it

     if ((Status & 0x300) != 0) {

         Stats[DMAERRORS]++;

         lseek(R3Bfh, DMA_CTRL, SEEK_SET);  
         Data32 = 2;        //  DMA block reset
         rc = write(R3Bfh, &Data32, 4);                  //  reset DMA
         Data32 = 0;        //  normal operation
         rc = write(R3Bfh, &Data32, 4);

         return 0;          // no data
     }

     if ((Status & 0x02) == 0x02)  return 0;    // no data

//   setup for DMA buffer

     lseek(Memfh, DMABufferOffset, SEEK_SET);
     rc = read(Memfh, &DataBuffer[0], BufSize*BLen);  //  read the whole DMA block into our buffer

//   write debug output if required 

     if (*dacq_TestMode == 10) {
         FILE *fh;
         fh = fopen("/tmp/RawData.dat", "a");
         fwrite(&DataBuffer[0], BufSize*BLen, 1, fh);
         fclose(fh);
     }

/*
 printf("data =");
  l = len/4;
  if (l > 64) l=64;
 for (i=0; i<l; i++) printf(" 0x%08x",DataBuffer[i]);
 printf("\n");
*/

      CurrentRDptr += BufSize;    // advance read pointer
      if (CurrentRDptr >= (MemSize*2)) CurrentRDptr = 0;

      DMABufferOffset += (BufSize*BLen);
      if (DMABufferOffset >= (MemSize*BLen)) DMABufferOffset = 0;

      lseek(R3Bfh, DMA_RDPTR, SEEK_SET);  
      Data32 = CurrentRDptr;
      rc = write(R3Bfh, &Data32, 4);        //  set block taken

//    update stats and control variable

      Stats[DMABLOCKS]++; 

      DataBufferLen = (BufSize*BLen)/4 ; //  This should be the number of ints in the buffer
      DataBufferOffset = 0; 

     return 1; 
}

/* --------------------------------------------------------------------- */

